#include <stdio.h>
#include <inttypes.h>
#include <unistd.h>

#include "magic.inc"

#define CMD "/bin/grep -in 0x%08x x.log | /bin/grep -e \\*\\ 0x%08x -e LOAD"

int main()
{
  char     command[128];
  uint32_t v_hi, v_lo;
  int      i;

  for (i=0; i<16; i++)
  {
    v_hi = magic_table[i] >> 32;
    v_lo = magic_table[i] & 0xffffffff;
    fprintf(stdout, ":: magic_table[%02d]\n", i);
    sprintf(command, CMD, v_hi, v_hi);
    fprintf(stdout, "%s\n", command);
    fflush(stdout);
    system(command);
    sprintf(command, CMD, v_lo, v_lo);
    fprintf(stdout, "%s\n", command);
    fflush(stdout);
    system(command);
  }

  v_hi = ROUND_MAGIC_HI >> 32;
  v_lo = ROUND_MAGIC_HI & 0xffffffff;
  fprintf(stdout, ":: ROUND_MAGIC_HI\n");
  sprintf(command, CMD, v_hi, v_hi);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);
  sprintf(command, CMD, v_lo, v_lo);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);

  v_hi = ROUND_MAGIC_LO >> 32;
  v_lo = ROUND_MAGIC_LO & 0xffffffff;
  fprintf(stdout, ":: ROUND_MAGIC_LO\n");
  sprintf(command, CMD, v_hi, v_hi);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);
  sprintf(command, CMD, v_lo, v_lo);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);

  v_hi = FINAL_MAGIC0 >> 32;
  v_lo = FINAL_MAGIC0 & 0xffffffff;
  fprintf(stdout, ":: FINAL_MAGIC2\n");
  sprintf(command, CMD, v_hi, v_hi);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);
  sprintf(command, CMD, v_lo, v_lo);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);
 
  v_hi = FINAL_MAGIC1 >> 32;
  v_lo = FINAL_MAGIC1 & 0xffffffff;
  fprintf(stdout, ":: FINAL_MAGIC1\n");
  sprintf(command, CMD, v_hi, v_hi);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);
  sprintf(command, CMD, v_lo, v_lo);
  fprintf(stdout, "%s\n", command);
  fflush(stdout);
  system(command);
}
